(defun DB-join (name1 name2) 
  (let ((db1 (if (member name1 DB-base) (symbol-value name1)))
	(db2 (if (member name2 DB-base) (symbol-value name2))))
    (if (and db1 db2)
	(let ((common nil) result)
	     (setf common (find-common (first db1) (first db2)))
	     (if common
		 (append
		     (list
		         (remove-duplicates
			     (append (first db1) (first db2))
                         )
                     )
		     (DB-join-aux (position common (first db1))
				  (position common (first db2))
				  (rest db1)
				  (rest db2)
				  result
                     )
                 )
		 (progn (print "no common field") nil)
             )
	)
        (cond
	    ((null db1) (format t "~S not found" name1))
	    (t (format t "~S not found" name2))
	)
    )
  )
)

(defun find-common (lst1 lst2)
    (if lst1
	(if (member (first lst1) lst2) (first lst1)
				       (find-common (rest lst1) lst2)
	)
    )
)

(defun DB-join-aux (loc1 loc2 data1 data2 result)
    (if data1
	(progn
	    (setf result
	        (DB-join-element loc1 loc2 (first data1) data2 result)
	    )
	    (DB-join-aux loc1 loc2 (rest data1) data2 result)
	)
	result
    )
)

(defun DB-join-element (l1 l2 record db r)
    (if db
	(if (equal (nth l1 record) (nth l2 (first db)))
	    (setf r
		(append r
		    (list
		        (remove-duplicates
			    (append record (first db))
			)
                    )
		)
	    )
	    (DB-join-element l1 l2 record (rest db) r)
	)
	(remove-duplicates r)
    )
)
		 
