(in-package "USER")

(defvar *goal* '(1 2 3 4 5 6 7 8 0))
(defvar *visited* nil)

(defun bf (start)
    (let (x y result)
	(setf x (get-internal-run-time))
	(setf *visited* nil)
	(if (solvable (correspond start) *goal*)
	    (setf result (best-first start))
	    (print "No Solution!")
	)
        (setf y (get-internal-run-time))
	(show result)
	(format t "~%Running time: ~S sec.~%"
		  (float (/ (- y x) internal-time-units-per-second))
        )
	(format t "Length: ~D~%" (length result))
    )
    "End"
)

(defun best-first (start)
    (let ((open (list (list (heuristic start) start))))
	(loop
	    (if (null open) (return "Error ? No, solution."))
	    (if (equal (second (first open)) *goal*)
	        (return (reverse (rest (first open))))
	    )
	    (let ((children (successors (second (first open)))))
	        (setf open (combine children (first open) (rest open)))
	    )
	)
    )
)

(defun successors (lst)
    (let ((zloc (location 0 lst)))
	(mapcar
	    #'(lambda (loc) (exchange zloc loc lst))
	    (rest (assoc zloc *next*))
	)
    )
)

(defun combine (new-lsts lst queue)
    (push (second lst) *visited*)
    (dolist (s new-lsts)
	(if (not (member s *visited* :test #'equal))
	    (push (cons (- (* 2 (heuristic s)) (1- (length lst)))
			(cons s (rest lst))
		  )
		  queue
	    )
        )
    )
    (sort queue #'> :key #'car)
)

(defun show (lst)
    (if lst
	(progn
	    (format t "~S~%" (first lst))
	    (show (rest lst))
	)
    )
)
