;
;  This program receives a arithmetic expression and optimize it.
;
;

(setf stack1  nil)
(setf stack2  nil)
(setf t1 nil)
(setf t2 nil)
(setf t3 nil)
(setf t4 nil)
(setf sub nil)

;--------------------------------------------------------------------------
; 
;    Main function to get the optimized arithmetic expression
;    from the given one

(defun simplify (lst)
    (simp lst)
    (first stack1)
)



;--------------------------------------------------------------------------
;    
;    Recursive function to optimize the given arithmetic expression
;

(defun simp (lst)
   (cond 
	 ((null lst)                           ; end of the sublist
                    (setf sub nil)             ; get the optimized sublist
		    (loop
		       (setf t4 (pop stack1))
		       (if (or (eq t4 ']) (eq t4 nil)) (return))
                       (setf sub (cons t4 sub))
                    )
                    (push  sub stack1)
	 )
	 ((atom (first lst))
		(cond 
		       ( (eq (first lst) '0 )  ; case of 0
			     (loop (setf t1 (pop stack1))
                                    (cond
                                          ((eq t1 '+)    ; effect of 0 on +
					       (push t1 stack1)
					       (loop (setf t2 (pop stack2))
					             (if (eq t2 nil) (return)
						         (push t2 stack1))
					       )
					       (simp (rest lst))
					       (return)
					  )
					  ((eq t1 '*)   ; effect of 0 on *
					       (pop stack1)
					       (setf stack2 nil) 
					       (return)
					  )
					  ( t  (push t1 stack2))
				    )
                             )
                       )
		       ( (eq (first lst) '1)              ; case of 1
			     (setf stack2 nil)
			     (loop 
				    (setf t3 (pop stack1))
				    (cond
                                          ((eq t3 '*)     ; effect of 1 on *
                                              (push t3 stack1)
					      (loop (setf t4 (pop stack2))
						    (cond
                                                          ((null t4) (return))
							  (t (push t4 stack1))
                                                    )
                                               )
					       (return)
					  )
					  ((eq t3 '+)     ; effect of 1 on +
					      (push t3 stack1)
					      (loop (setf t4 (pop stack2))
                                                    (cond
                                                           ((null t4) (return))
							   (t (push t4 stack1))
						    )
					      )
					      (push (first lst) stack1)
					      (return)
					  )
					  (t (push t3 stack2))
				    )
			     )
			     (simp (rest lst))
		       )
		       ( (eq (first lst) '+ )     ; case of +
			     (push '] stack1)
                             (push '+ stack1 )
			     (simp (rest lst))
		       )
		       ( (eq (first lst) '*)      ; case of *
			     (push '] stack1)
			     (push '* stack1 )
			     (simp (rest lst))
		       )
		       ( t  (push  (first lst) stack1) (simp (rest lst))  )
		)
         )
	 ((listp (first lst))                     ; case of sublist
		 (cond 
		       ( (eq (caar lst) '+)       ; case of +
			     (push '] stack1)
			     (push '+ stack1)
                             (simp (cdar lst))
			     (simp (rest lst))
		       )
		       ( (eq (caar lst) '*)       ; case *
			     (push '] stack1)
                             (push '* stack1)
			     (simp (cdar lst))
			     (simp (rest lst))
		       )
                 )
         ) 
   )
)

