(in-package "USER")

(setf *input* '(a b c d e f g h i j))
(defvar *feature* nil)
(defvar *peak* 5)
(defvar *pattern*)

(defun projection ()
    (setf *feature* nil)
    (project *input*)
)

(defun project (lst)
    (let ((ele (first lst)))
	(if (null ele)
	    (progn
	        (format t "End of study and the result is as follow.~%")
		(format t "~S~%" *feature*)
	    )
	    (progn
	        (setf *feature*
		    (append *feature* (list (analysis ele)))
		)
		;(format t "*feature*:~S~%" *feature*)
	        (project (rest lst))
	    )
	)
    )
)

(defun analysis (ch)
    (let ((ary nil))
	(setf ary (input ch))
	(append
	    (list ch)
	    (append (which-peak (h-scan ary)) 
		    (which-peak (v-scan ary))
	    )
	)
    )
)

(defun input (ch)
    (format t "Please give me the scanned image of ~S~%" ch)
    (read)
)

(defun h-scan (ary)
    (loop as i from 0 to 31
	collect
	    (loop for j from 0 to 31 do sum (aref ary i j))
    )
)

(defun v-scan (ary)
    (loop as i from 0 to 31
	collect
	    (loop for j from 0 to 31 do sum (aref ary j i))
    )
)

(defun which-peak (lst)
    (let ((range nil))
	(setf range (get-range lst))
	(setf *pattern* nil)
	(loop as i from (first range) to (last range)
	    do (record i lst range)
	)
    )
)

(defun record (i lst range)
    (let ((value 0))
	(if (< i 31)
	    (if (equal (nth i lst) (nth (1+ i) lst))
		(setf value 2)
		(setf value 1)
	    )
	    (setf value 1)
	)
        (if (zerop i)
	    (if (setf value (ispeak 0 (nth i lst)))
	        (append *pattern* (* value 1))
	    )
	    (if (setf value (ispeak (nth (1- i) lst) (nth i lst)))
	        (cond
		    ( (< i (/ 3 (- (last range) (first range))))
		        (append *pattern* (* value 1))
		    )
		    ( (> i (* 2 (/ 3 (- (last range) (first range)))))
		        (append *pattern* (* value 3))
		    )
		    ( t (append *pattern* (* value 2)) )
		)
	    )
	)
    )
)

(defun ispeak (num current)
    (cond
	((and (equal num 0) (> current *peak*)) T)
	((> (- current num) *peak*) T)
	(t nil)
    )
)
