(in-package "USER")

(setf *input* '(a b c d e f g h i j))
(defvar *feature* nil)
(defvar *peak* 5)
(defvar *pattern*)

(defun projection ()
    (setf *feature* nil)
    (project *input*)
)

(defun project (lst)
    (let ((ele (first lst)))
	(if (null ele)
	    (progn
	        (format t "End of study and the result is as follow.~%")
		(format t "~S~%" *feature*)
	    )
	    (progn
	        (setf *feature*
		    (append *feature* (list (analysis ele)))
		)
		;(format t "*feature*:~S~%" *feature*)
	        (project (rest lst))
	    )
	)
    )
)

(defun analysis (ch)
    (let ((ary nil))
	(setf ary (input ch))
	(append
	    (list ch)
	    (append (which-peak (h-scan ary)) 
		(append '(0)
		    (which-peak (v-scan ary))
		)
	    )
	)
    )
)

(defun input (ch)
    (format t "Please give me the scanned image of ~S~%" ch)
    (read)
)

(defun h-scan (ary)
    (loop as i from 0 to 31
	collect
	    (loop for j from 0 to 31 do sum (aref ary i j))
    )
)

(defun v-scan (ary)
    (loop as i from 0 to 31
	collect
	    (loop for j from 0 to 31 do sum (aref ary j i))
    )
)

(defun which-peak (lst)
    (let ((range nil))
	(setf range (get-range lst))
	(setf *pattern* nil)
	(loop as i from (first range) to (second range)
	    do (record i lst range)
	)
	*pattern*
    )
)

(defun get-range (lst)
    (list (start lst) (end (reverse lst)))
)

(defun start (lst)
    (cond
	( (zerop (first lst)) 
	    (1+ (start (rest lst)))
	)
	( (plusp (first lst)) 0 )
    )
)

(defun end (lst)
    (cond
	( (zerop (first lst))
	    (1- (end (rest lst)))
        )
	( (plusp (first lst)) 31 )
    )
)

(defun record (i lst range)
    (let ((value 0))
	(if (< i 31)
	    (if (equal (nth i lst) (nth (1+ i) lst))
		(setf value 2)
		(setf value 1)
	    )
	    (setf value 1)
	)
        (if (zerop i)
	    (if (ispeak 0 (nth i lst))
	        (setf *pattern*
		    (append *pattern*
			(list (* value 1))
		    )
		)
	    )
	    (if (ispeak (nth (1- i) lst) (nth i lst))
		;(progn 
		 ;   (format t "i:~S v:~S~%" i value)
		 ;   (format t "l-i:~S" (- (second range) i))
		 ;   (format t " ~S~%" (/ 3 
		;	(- (second range) (first range))) )
	        (cond
		    ( (< (- i (first range))
			    (/ (- (second range) (first range)) 3))
		        ( setf *pattern*
			    (append *pattern*
				(list (* value 1))
			    )
			)
		    )
		    ( (> (- i (first range))
			    (* 2 (/ (- (second range) (first range)) 3)))
		        (setf *pattern*
			    (append *pattern*
				(list (* value 4))
			    )
			)
		    )
		    ( t (setf *pattern*
			    (append *pattern*
				(list (* value 3))
			    )
			)
		    )
		);)
	    )
	)
    )
)

(defun ispeak (num current)
    (cond
	((and (equal num 0) (> current *peak*)) T)
	((> (- current num) *peak*) T)
	(t nil)
    )
)
