(in-package "USER")

(defvar *result*)
(defvar *AMB*)
(defvar *POS*)
(defvar *UNC*)

(defun player ()
    (format t "~%Give me a command list!~%")
    (loop
	(let ((input (read)))
	    (setf *result* nil)
	    (setf *AMB* nil)
	    (setf *POS* nil)
	    (setf *UNC* nil)
	    (cond 
		( (equal (first input) 'Play) (play (rest input)) )
	        ( (equal (first input) 'HELP) (help-message) )
		( (equal (first input) 'EXIT) (return "Bye") )
		( t (error-message) )
	    )
	)
    )
)

(defun play (lst)
    ;(format t "Play:~S~%" lst)
    (A lst)
    (cond
	( *AMB* (format t "~S~%"
		    (append '(ambiguous but most likey) (display))
		)
	)
	( *POS* (format t "~S~%"
		    (append '(Possibly) (display))
		)
	)
	( *UNC* (format t "ERROR: Sorry, range unclear~%") )
	( t (format t "~S~%" (display) ) )
    )
)

(defun A (lst)
    (let ((ele (first lst)))
	;(format t "lst:~S ele:~S r:~S~%" lst ele *result*)
	;(if (listp lst) (format t "~S is list~%" lst)
        ;		(format t "~S is not list~%" lst) )
        (cond
	    ( (null lst) nil )
	    ( (numberp ele)
	        (if (null (rest lst))
		    (if (null *result*)
		        (push lst *result*)
		        (push ;(append (pop *result*) (list ele) ) 
			      (list ele)
			      *result*
		        )
		    )
		    (progn
			;(format t "Lst:~S~%" lst)
			(A (list ele))
			(B (rest lst))
		    )
		)
	    )
	    ( (equal ele '[) (P (rest lst)) )
	    ( (equal ele 'reversed)
		(push (reverse (pop *result*)) *result*)
	    )
	    ( (equal ele 'shuffled) (push (shuffle) *result*) )
	    ( (equal ele 'to) (setf *UNC* t) )
	    ( t (format t "No such ~S can be known~%" ele) )
	)
    )
)

(defun B (lst)
    (let ((ele (first lst)))
        (cond 
	    ( (equal ele 'and) (A (rest lst)) )
	    ( (equal ele 'to) (C (rest lst)) )
	    ( (equal ele 'repeat) (D (rest lst)) )
	    ( (numberp ele) (E lst) )
	    ( t (format t "Not supported yet~%") )
        )
    )
)

(defun C (lst)
    (let ((ele (first lst)))
	(if (numberp ele)
	    (cond
		( (numberp (second lst))
		    (progn
			(push (list ele) *result*)
			(F (rest lst))
		    )
		)
		( t (progn
		        (push (sequence ele) *result*)
		        (cond 
			    ( (equal (second lst) 'without) 
			        (W (rest lst))
			    )
			    ( (equal (second lst) 'and)
				(B (rest lst))
			    )
			    ( (equal (second lst) 'repeat)
				(B (rest lst))
			    )
			    ( t (A (rest lst)) )
			)
	     	    )
		)
	    )
	    (error-message)
	)
    )
)

(defun D (lst)
    (let ((ele (first lst)))
	(if (numberp ele)
	    (if (equal (second lst) 'times)
		(repeat ele)
		(error-message)
	    )
	    (error-message)
	)
    )
)

(defun repeat (num)
    (if (zerop (1- num))
	nil
	(progn
	    (push (first *result*) *result*)
	    (repeat (1- num))
	)
    )
)

(defun E (lst)
    (push (list (+ (* (first (pop *result*)) 10) (first lst))) 
	  *result*
    )
    (if (numberp (second lst))
	(E (rest lst))
	(B (rest lst))
    )
)

(defun F (lst)
    (push (list (+ (* (first (pop *result*)) 10) (first lst)))
	*result*
    )
    (if (numberp (second lst))
	(F (rest lst))
	(progn
	    (let ((ele (first (pop *result*))))
	        (push (sequence ele) *result*)
	    )
	    (if (equal (second lst) 'without)
		(W (rest lst))
		(A (rest lst))
	    )
	)
    )
)

(defun P (lst)
    (push '([) *result*)
    (let ((rst nil))
        (setf rst (Q lst))
	;(format t "rst:~S{~S}~%" rst *result*)
	(rmerge)
	(if (null rst) (A rst) (B rst))
    )
)

(defun rmerge()
    (let ((lst nil))
	(setf lst (merge-aux))
	(if (not (null lst))
	    (push lst *result*)
	)
    )
)

(defun merge-aux()
    (if (null *result*) 
	(error-message)
	(let ((lst nil))
	    (setf lst (pop *result*))
	    (if (equal (first lst) '[) 
		nil
	        (append (merge-aux) lst)
	    )
	)
    )
)

(defun Q (lst)
    (let ((prelst nil)(postlst nil))
        (setf prelst (prevalue lst))
	(setf postlst (pop *result*))
	(A prelst)
        postlst
    )
)

(defun prevalue (lst)
    (if (equal (first lst) '])
	(progn
	    (push (rest lst) *result*)
	    nil
	)
	(append (list (first lst)) (prevalue (rest lst)))
    )
)

(defun sequence(num)
    (let ((lst (pop *result*)))
	(if (> (first lst) num)
	    (to-error-message)
 	    (seq-aux lst num)
	)
    )
)

(defun seq-aux (lst num)
    (if (equal (first lst) num)
	lst
	(append (seq-aux  lst (1- num)) (list num))
    )
)

(defun W (lst)
    (setf lst (rest lst))
    (let ((ele (first lst)))
	(if (numberp ele)
	    (progn
	        (removal (list ele))
		(V (rest lst))
	    )
	    (if (equal ele '[)
		(progn
		    (P (rest lst))
		    ;(format t "in W:~S~%" *result*)
		    (removal (pop *result*))
		)
	    )
	)
    )
)

(defun V (lst)
    (let ((ele (first lst)))
	(if (equal ele 'and)
	    (progn
		(setf *AMB* t)
		(if (include (second lst))
		    (removal (list (second lst)))
		    (A (rest lst))
		)
	    )
	    (A lst)
	)
    )
)

(defun removal (lst)
    (if (null lst) 
	nil
	(if (include (first lst))
	    (let ((newlst nil))
		(setf newlst (remove-aux (first lst) (pop *result*)))
		(push newlst *result*)
		(removal (rest lst))
	    )
	)
    )
)

(defun remove-aux (ele lst)
    (if (null lst)
	nil
	(if (not (equal ele (first lst)))
	    (append (list (first lst)) (remove-aux ele (rest lst)))
	    (append nil (remove-aux ele (rest lst)))
	)
    )
)

(defun include (ele)
    (member ele (first *result*))
)

(defun shuffle ()
    (let ((lst nil)(ele nil))
	(setf *POS* t)
	(setf lst (pop *result*))
	(append 
	    (list 
		(setf ele (nth (random (length lst)) lst))
	    )
	    (shuf-aux (remove-aux ele lst))
	)
    )
)

(defun shuf-aux (lst)
    (let ((ele nil))
        (if (null lst)
	    nil
	    (append
	        (list
		    (setf ele (nth (random (length lst)) lst))
		)
		(shuf-aux (remove-aux ele lst))
	    )
	)
    )
)

(defun help-message ()
    (format t 
	"Type a list, 'Play' followed by range of numbers~%"
    )
)

(defun error-message()
    (format t
	"ERROR: type (HELP) for help, (EXIT) to exit~%"
    )
)

(defun to-error-message()
    (format t
	"ERROR: Sorry, second number should be higher than the first~%"
    )
)

(defun display ()
    (let ((lst nil))
        (if (null *result*)
	    nil
	    (progn
	        (setf lst (pop *result*))
                (append (display) lst)
	    )
	)
    )
)
