(in-package "USER")

(setf *input* '(a b c d e f g h i j))
(defvar *feature* nil)
(defvar *peak* 5)

(defun projection ()
    (setf *feature* nil)
    (project *input*)
)

(defun project (lst)
    (let ((ele (first lst)))
	(if (null ele)
	    (progn
	        (format t "End of study and the result is as follow.~%")
		(format t "~S~%" *feature*)
	    )
	    (progn
	        (setf *feature*
		    (append *feature* (list (analysis ele)))
		)
		;(format t "*feature*:~S~%" *feature*)
	        (project (rest lst))
	    )
	)
    )
)

(defun analysis (ch)
    (let ((ary nil))
	(setf ary (input ch))
	(append
	    (list ch)
	    (append (count-peak (h-scan ary)) 
		    (count-peak (v-scan ary))
	    )
	)
    )
)

(defun input (ch)
    (format t "Please give me the scanned image of ~S~%" ch)
    (read)
)

(defun h-scan (ary)
    (loop as i from 0 to 31
	collect
	    (loop for j from 0 to 31 do sum (aref ary i j))
    )
)

(defun v-scan (ary)
    (loop as i from 0 to 31
	collect
	    (loop for j from 0 to 31 do sum (aref ary j i))
    )
)

(defun count-peak (lst)
    ;(format t "cout-peak:~S~%" lst)
    (let ((num 0))
	(list (ispeak num lst))
    )
)

(defun ispeak (num lst)
;    (format t "ipeak: ~S ~S~%" num lst)
    (cond
	((null lst) 0)
	((and (equal num 0) (> (first lst) *peak*))
	    (1+ (ispeak (first lst) (rest lst)))
	)
	((> (- (first lst) num) *peak*)
	    (1+ (ispeak (first lst) (rest lst)))
	)
	(t (ispeak (first lst) (rest lst)))
    )
)
