(in-package "USER")

(defun score ()
    (+ (blue-score) (red-score))
)

(defun blue-score ()
    (get-score (blue-pieces))
)

(defun red-score ()
    (minus (get-score (red-pieces)))
)

(defun minus (num)
    (- 0 num)
)

(defun get-score (lst)
    (if (null lst)
	0
	(let ((piece (second (first lst))))
	    (+ (nth piece *piece-score*) (get-score (rest lst)))
	)
    )
)

(defun blue-pieces ()
    (loop as i from 0 to 8
	do append (loop for j from 0 to 9
	    when (oddp (aref *board* i j))
	        append (list (list (list i j) (aref *board* i j)))
	)
    )
)

(defun red-pieces ()
    (loop as i from 0 to 8
	do append (loop for j from 0 to 9
	    when (and (evenp (aref *board* i j))
		      (plusp (aref *board* i j))
		 )
		append (list (list (list i j) (aref *board* i j)))
        )
    )
)

