(in-package "USER")

(defun show ()
    (loop for j from 9 downto 0
	do (loop for i from 0 to 8 do (draw i j))
    )
)

(defun draw (x y)
    (cond
	( (= y 0) (draw-zero x) )
	( (= y 1) (draw-one x y) )
	( (= y 2) (draw-two x y) )
	( (= y 8) (draw-one x y) )
	( (= y 9) (draw-two x y) )
	( t (draw-normal x y) )
    )
)

(defun draw-zero (x)
    (let ((piece (get-piece (list x 0))))
        (cond
	    ( (= 0 piece)
		(if (= 0 x) (draw-side 0))
		(if (= 8 x) (draw-bottom :b t)
		            (draw-space x)
		)
	    )
	    ( (= 8 x) (draw-bottom :p piece) )
	    ( t (if (= 0 x) (draw-side 0))
		(draw-piece piece)
	    )
        )
    )
)

(defun draw-bottom (&key b p)
    (if b (draw-right) (draw-piece p))
    (format t "~%.  A  B  C  D  E  F  G  H  I~%")
)

(defun draw-right ()
    (princ "-+")
)

(defun draw-left ()
    (princ " +-")
)

(defun draw-side (y)
    (format t "~1D " y)
)

(defun draw-space (num)
    (cond
	( (= 0 num) (draw-left) )
	( (= 8 num) (draw-right) )
	( t (princ "-+-") )
    )
)

(defun draw-one (x y)
    (let ((piece (get-piece (list x y))))
	(cond
	    ( (= 0 piece)
		(if (= 0 x) (draw-side y))
		(if (= 4 x) (draw-throne)
		            (draw-space x)
		)
		(if (= 8 x)
		    (format t "~%.  |  |  |  | /|\\ |  |  |  |~%")
		)
	    )
	    ( t (if (= 0 x) (draw-side y))
		(draw-piece piece)
		(if (= 8 x)
		    (format t "~%.  |  |  |  | /|\\ |  |  |  |~%")
		)
	    )
        )
    )
)

(defun draw-throne ()
    (princ "-X-")
)

(defun draw-two (x y)
    (let ((piece (get-piece (list x y))))
	(cond
	    ( (= 0 piece)
	        (if (= 0 x) (draw-side y))
	        (draw-space x)
	        (if (= 8 x)
		    (format t "~%.  |  |  |  | \\|/ |  |  |  |~%")
	        )
	    )
	    ( t (if (= 0 x) (draw-side y))
		(draw-piece piece) 
		(if (= 8 x)
		    (format t "~%.  |  |  |  | \\|/ |  |  |  |~%")
		)
	    )
	)
    )
)

(defun draw-normal (x y)
    (let ((piece (get-piece (list x y))))
	(cond
	    ( (= 0 piece)
		(if (= 0 x) (draw-side y))
		(draw-space x)
		(if (= 8 x)
		    (format t "~%.  |  |  |  |  |  |  |  |  |~%")
		)
	    )
	    ( t (if (= 0 x) (draw-side y))
		(draw-piece piece)
		(if (= 8 x)
		    (format t "~%.  |  |  |  |  |  |  |  |  |~%")
		)
	    )
    	)
    )
)

(defun draw-piece (piece)
    (cond
	( (= 1 piece) (princ "[r]") )
	( (= 2 piece) (princ "[R]") )
	( (= 3 piece) (princ "[n]") )
	( (= 4 piece) (princ "[N]") )
	( (= 5 piece) (princ "[b]") )
	( (= 6 piece) (princ "[B]") )
	( (= 7 piece) (princ "[g]") )
	( (= 8 piece) (princ "[G]") )
	( (= 9 piece) (princ "[k]") )
	( (= 10 piece) (princ "[K]") )
	( (= 11 piece) (princ "[c]") )
	( (= 12 piece) (princ "[C]") )
	( (= 13 piece) (princ "[p]") )
	( (= 14 piece) (princ "[P]") )
    )
)
