;  ************************ No. 14 **************************
;
;  This program shows if a list represents quasi-balanced tree.
;  If it is quasi-balanced-tree, it returns T, otherwise NIL
;  The definition of Quasi-balanced tree is that all top-level
;  sublists has the same length and the same depth

;-----------------------------------------------------------------
; 
;  This function calculates the length of a given list
;

(defun len (lst)
     (cond ((null lst) 0)
           (t (1+ (len (rest lst))))))

;-----------------------------------------------------------------
; 
; This function decides if the given sublists have the same length
;

(defun q_len (lst)
   (cond  ((null lst) t)
	  ((null (rest lst)) t)
	  (t (and (= (len (first lst)) (len (second lst)))
		  (q_len (rest lst))  
             )
          )
   )
)

;-----------------------------------------------------------------
;
;  This function decides if the given sublists have the same depth
;


(defun q_depth (lst)
    (cond ((null lst) t)
	  ((null (rest lst)) t)
	  (t (and (= (dep (first lst)) (dep (second lst)))
		  (q_depth (rest lst))
             )
          )
    )
)

;-----------------------------------------------------------------
;
;  This function calculates the maximum depth of a given list
;


(defun dep (lst)
   (cond ((null lst) 0)
	 ((atom lst) 0)
	 ((atom (first lst)) (dep (rest lst)))
         ((listp (first lst)) 
	     (if (> (+ 1 (dep (first lst))) (dep (rest lst)))
		 (+ 1 (dep (first lst))) (dep (rest lst)) 
             )
         )
    )
)

;-----------------------------------------------------------------
;
; This function decides if a given list is a quasi-balanced tree
;



(defun quasi-balanced-p (lst)
      (and (q_len lst) (q_depth lst))
)

;-----------------------------------------------------------------

