//------------------------------------------------------------------------
// BrownMove applet
// This applet simulates Brown Movement - a particle moves randomly.
// The movemnet begins from the center of screen. If the particle
// reached the boundary, a new particle will be appeared on the
// center postion and start moving.
//
// @author Jungkee Kim
// @version 1.0, 2/5/97

import java.applet.*;
import java.awt.*;
import java.lang.Math;
import java.util.*;

public class BrownMove extends Applet implements Runnable {

    Thread thread;				//Thread variable
    Date now = new Date();			//For random seed
    Random r = new Random(now.getTime());	//Random number
    int select;					//Direction of move
    int	x = 50, y = 50;				//Coordination

    public void init() {			//Initialization
	thread = new Thread(this);
    }

    public void start() {

	if (thread.isAlive()) {		//Checking the life of thread
	    thread.resume();		//If other page reference,
	}				// resume the thread.

	else {				//Start thread from begining
	    thread.start();
	}
    }

    public void stop() {		//Stop thread.
	thread.suspend();
    }

    public void destroy() {		//Destroy thread.
	thread.stop();
    }

    public void run() {
	setBackground(Color.white);	//Set background as the white color

	while (true) {
	    //Make selection of next movement - one of 0 to 3
	    select = Math.abs( r.nextInt()% 4 ); 
	    switch(select) {
		case 0 : x+=5; break;		//right move
		case 1 : x-=5; break;		//left move
		case 2 : y+=5; break;		//up move
		case 3 : y-=5; break;		//down move
		default : break;		//never reached
	    }

	    //Out of boundary condition
	    if ( x < 0 || x > 95 || y < 0 || y > 95) {
		x = 50;
		y = 50;
		repaint();			//Call paint method
		try { Thread.sleep(300); }	//Pause for 0.3 second
		catch (InterruptedException e) {}
	    }
	    else {
	        repaint();
	        try { Thread.sleep(100); }
	        catch (InterruptedException e) {}
	    }
	}
    }

    public void paint(Graphics g) {
	g.setColor(Color.red);		//Set the dot as red color
	g.fillOval(x, y, 5, 5);		//Make the dot
    }
}
