import java.applet.*;
import java.awt.*;
import java.lang.Math;
import java.util.*;

public class hw3 extends java.applet.Applet {
    BrownMoveCanvas	paper;
    BrownMovePanel	board;

    public void init() {
	setLayout(new GridLayout(1, 2, 15, 10));
	paper = new BrownMoveCanvas(this);
	board = new BrownMovePanel(this);
	add(paper);
	add(board);
	paper.setBackground(Color.white);
	board.setBackground(Color.pink);
    }

    public void paint (Graphics g) {
	//paper.setBackground(Color.white);
	//board.setBackground(Color.pink);
	//board.setBackground(Color.lightGray);
	paper.paint(g);
	board.paint(g);
    }

    public void start() {
	paper.start();
	board.start();
    }
    
    public void stop() {
	paper.stop();
    }

    public void update(Graphics g) {
	paper.paint(g);
    }
}

class BrownMoveCanvas extends Canvas implements Runnable {

    hw3	parent;
    Thread thread;				//Thread variable
    Date now = new Date();			//For random seed
    Random r = new Random(now.getTime());	//Random number
    Color dot_color = Color.red;		//Dot color
    int select;					//Direction of move
    int	x = 65, y = 70;				//Coordination

    public BrownMoveCanvas(hw3 parent) {
	this.parent = parent;
	thread = new Thread(this);
    }

    public void start() {

	if (thread.isAlive()) {		//Checking the life of thread
	    thread.resume();		//If other page reference,
	}				// resume the thread.

	else {				//Start thread from begining
	    thread.start();
	}
    }

    public void stop() {		//Stop thread.
	thread.suspend();
    }

    public void destroy() {		//Destroy thread.
	thread.stop();
    }

    public void run() {
	//setBackground(Color.white);	//Set background as the white color

	while (true) {
	    //Make selection of next movement - one of 0 to 3
	    select = Math.abs( r.nextInt()% 4 ); 
	    switch(select) {
		case 0 : x+=5; break;		//right move
		case 1 : x-=5; break;		//left move
		case 2 : y+=5; break;		//up move
		case 3 : y-=5; break;		//down move
		default : break;		//never reached
	    }

	    //Out of boundary condition
	    if ( x < 0 || x > 145 || y < 0 || y > 145) {
		x = 65;
		y = 70;
		repaint();			//Call paint method
		try { Thread.sleep(300); }	//Pause for 0.3 second
		catch (InterruptedException e) {}
	    }
	    else {
	        repaint();
	        try { Thread.sleep(100); }
	        catch (InterruptedException e) {}
	    }
	}
    }

    public void paint(Graphics g) {
	g.setColor(dot_color);		//Set the dot as selected color
	g.fillOval(x, y, 5, 5);		//Make the dot
    }

    public void update_background(int color) {
	switch( color ) {
	    case 1 : setBackground(Color.black);
		     break;
	    case 2 : setBackground(Color.gray);
		     break;
	    case 3 : setBackground(Color.white);
		     break;
	    default: break;
	}
    }

    public void update_dot_color(int color) {
	switch( color ) {
	    case 1 : dot_color = Color.red;
		     break;
	    case 2 : dot_color = Color.green;
		     break;
	    case 3 : dot_color = Color.blue;
		     break;
	    default: break;
	}
    }
}

class BrownMovePanel extends Panel {
    hw3	parent;
    Choice bg;
    Choice particle;
    Label  lb, lp;

    BrownMovePanel(hw3 parent) {
	this.parent = parent;
	setLayout(new GridLayout(4, 1, 10, 5));

	lb = new Label("Background", Label.CENTER);
	add(lb);
	lb.setBackground(Color.white);

	bg = new Choice();

	bg.addItem("black");
	bg.addItem("gray");
	bg.addItem("white");
	bg.select(2);
	add(bg);

	lp = new Label("Particle", Label.CENTER);
	add(lp);
	lp.setBackground(Color.red);
	lp.setForeground(Color.blue);

	particle = new Choice();

	particle.addItem("red");
	particle.addItem("green");
	particle.addItem("blue");
	particle.select(0);
	add(particle);
    }

    public void start() {
    }

    public void paint(Graphics g) {
    }

    public boolean action(Event evt, Object arg) {
	String	label = (String) arg;

	if (evt.target instanceof Choice) {
	    if ((Choice)evt.target == bg) {
		if (label.equals("black")) {
		    parent.paper.update_background(1);
		    lb.setBackground(Color.black);
		    lb.setForeground(Color.white);
		}
		else if (label.equals("gray")) {
		    parent.paper.update_background(2);
		    lb.setBackground(Color.gray);
		    lb.setForeground(Color.orange);
		}
		else if (label.equals("white")) {
		    parent.paper.update_background(3);
		    lb.setBackground(Color.white);
		    lb.setForeground(Color.black);
		}
		return true;
	    }
	    else if ((Choice)evt.target == particle) {
		if (label.equals("red")) {
		    parent.paper.update_dot_color(1);
		    lp.setBackground(Color.red);
		    lp.setForeground(Color.yellow);
		}
		else if (label.equals("green")) {
		    parent.paper.update_dot_color(2);
		    lp.setBackground(Color.green);
		    lp.setForeground(Color.magenta);
		}
		if (label.equals("blue")) {
		    parent.paper.update_dot_color(3);
		    lp.setBackground(Color.blue);
		    lp.setForeground(Color.cyan);
		}
		return true;
	    }
	    return true;
	}
	else return false;
    }
}
