#! /usr/local/bin/perl

#############################################################################
# Add.pl
# This perl program gets data from the HTML form of Add.html and appends
# records on the flat file database, faculty.db.
#
# @author Jungkee (Jake) Kim
#

#----------------------------------------------------------------------------
# Main Function
#

&PrintHeader;
&ReadEntry &&
&AddData;

#----------------------------------------------------------------------------
# Subroutines
#
 
#------------------------------------------
# PrintHeader
# This subroutine returns the magic line.
# Magic line informs to WWW that this is an HTML document.
 
sub PrintHeader {
    print "Content-type: text/html\n\n";
}
 
#------------------------------------------
# ReadEntry
# Read entry from the user adding form.

sub ReadEntry {
    &ReadParse;
    $name = $in{'name'};
    $phone = $in{'phone'};
    $room = $in{'room'};
    $email = $in{'email'};
    return 1;
}

#------------------------------------------
# AddData
# Append a record to the file and diplay the result.

sub AddData {
    
    &AddDataFile;

    print "<HTML>\n";
    print "<HEAD>\n";
    print "<TITLE>Adding a record</TITLE>\n";
    print "</HEAD>\n";
    print "<BODY>\n\n";
    print "<H1>Your input data:</H1>";
    print "&nbsp;Name: $name<BR>\n";
    print "&nbsp;Phone number: $phone<BR>";
    print "&nbsp;Room number: $room<BR>";
    print "&nbsp;E-mail address: $email<BR>\n";
    print "<H1>have been saved.</H1>\n";
    print "</BODY>\n";
    print "</HTML>\n";

    return 1;
}

#------------------------------------------
# ReadParse
# This subroutine reads the arguments passed from the fill-out form.
 
sub ReadParse {
    local ($i, $loc, $key, $val);

    # Note the added else-block for command line debugging:
    if ($ENV{'REQUEST_METHOD'} eq "GET") {		# Read in text
        $in = $ENV{'QUERY_STRING'};
    }
    elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
        for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
            $in .=getc;
        }
    }
    else {  # can be used for debugging on command line
        $in = <STDIN>;
        print "$in\n";
    }

    # Split input string into an array of strings:
    @in = split(/&/,$in);

    # Process each array element individually:
    foreach $i (0 .. $#in) {
        $in[$i] =~ s/\+/ /g;		# Convert plus signs to spaces
        $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
                                # Convert %XX from hex numbers to alphanumeric
        $loc = index($in[$i], "=");		# Split onto key and value.
        $key = substr($in[$i],0,$loc);		# Extract the key
        $val = substr($in[$i],$loc+1);		# Extract the value
        $in{$key} .= '\0' if (defined($in{$key}));
						#\0 is the multiple separator
        $in{$key} .= $val;
    }
    return 1;
}

#------------------------------------------
# AddDataFile
# Append a record on flat file, faculty.db.

sub AddDataFile {
    open (DATAOUT, ">>faculty.db") || die "Error: Cant open faculty.db file.";
    flock (DATAOUT, 2);
    print DATAOUT "$name/";
    print DATAOUT "$phone/";
    print DATAOUT "$room/";
    print DATAOUT "$email\n";
    flock(DATAOUT, 8);
    close(DATAOUT);
    return 1;
}
