#----------------------
# ReadParse
# This subroutine reads the arguments passed from the fill-out form
 
sub ReadParse {
    local ($i, $loc, $key, $val);

    # Note the added else-block for command line debugging:
    if ($ENV{'REQUEST_METHOD'} eq "GET") {		# Read in text
        $in = $ENV{'QUERY_STRING'};
    }
    elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
        for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
            $in .=getc;
        }
    }
    else {  # can be used for debugging on command line
        $in = <STDIN>;
        print "$in\n";
    }

    # Split input string into an array of strings:
    @in = split(/&/,$in);

    # Process each array element individually:
    foreach $i (0 .. $#in) {
        $in[$i] =~ s/\+/ /g;		# Convert plus signs to spaces
        $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
                                # Convert %XX from hex numbers to alphanumeric
        $loc = index($in[$i], "=");		# Split onto key and value.
        $key = substr($in[$i],0,$loc);		# Extract the key
        $val = substr($in[$i],$loc+1);		# Extract the value
        $in{$key} .= '\0' if (defined($in{$key}));
						#\0 is the multiple separator
        $in{$key} .= $val;
    }
    return 1;
}
