#! /usr/local/bin/perl

#############################################################################
# hamburg.pl
# This perl program shows the order from the user input order form.
#
# @author Jungkee Kim
#

#----------------------------------------------------------------------------
# Main Function
#

&PrintHeader;
&ReadEntry &&
&GetPrice;
&PrintResult;

#----------------------------------------------------------------------------
# Subroutines
#

#----------------------
# PrintHeader
# This subroutine returns the magic line.
# Magic line informs to WWW that this is an HTML document.

sub PrintHeader {
    print "Content-type: text/html\n\n";
}

#----------------------
# ReadEntry
# Read entry from the user order form.

sub ReadEntry {
    &ReadParse;		#Read arguments passed from fill-out form
			# referred from example
    $total = 0;
    $burger1 = $in{'cheese'};
	if ($burger1 eq 'on') {
            $b1 = '    Cheeseburger';
	    $total += 1.5;
	}
    $burger2 = $in{'double'};
	if ($burger2 eq 'on') { 
            $b2 = '    Doubleburger';
	    $total += 2.5;
	}
    $burger3 = $in{'chicken'};
	if ($burger3 eq 'on') { 
            $b3 = '    Chickenburger';
	    $total += 3.0;
	}
    $burger4 = $in{'fish'};
	if ($burger4 eq 'on') { 
            $b4 = '    Fishburger'; 
	    $total += 2.75;
	}
    $drink = $in{'Drink'};
    $herego = $in{'herego'};
    $name = $in{'name'};
    $phone = $in{'phone'};
    $when = $in{'when'};
    return 1;
}

#----------------------
# GetPrice
# Caculate the price.

sub GetPrice {
    if ($drink ne 'No drink') {              #if orded a drink
        if ($drink eq 'Small Coffee') {
            $total += 0.5;}
        elsif ($drink eq 'Small Cola') {
            $total += 0.6;}
        elsif ($drink eq 'Small Milk' || 
               $drink eq 'Medium Cola' ||
               $drink eq 'Large Coffee') {
            $total += 0.75;}
        else {$total += 0.9;}               #other drinks
    }
    return 1;
}

#----------------------
# PrintResult
# Print the result as HTML form.

sub PrintResult {
    print "<TITLE> Burger Order </TITLE>";
    print "<H1> Burger Order </H1>";
    
    if ($total == 0) {
        print "<BLINK><H1>Please order at least one item!!!</H1></BLINK>"}
    else {
        print "<H3>You ordered ";
        print "<FONT Color=red>$b1 $b2 $b3 $b4 </FONT>";
        print "with <FONT Color=blue> $drink</FONT>.<BR>";
        print "Total price is <FONT Color=magenta>\$";
        printf ("%5.2f</FONT>.<BR><BR>", $total);
        print "<I>Please come to </I>";
        print "<FONT Color=cyan>";
        if ($herego eq 'drivein') {
            print "Drive-in place </FONT><I>and pick up"; }
        elsif ($herego eq 'go') {
            print "our store </FONT><I>and take out";}
        else { print "our store </FONT><I>and have it"; }
        print "</I> after ";
        $date = `date`;
        print "$when from $date.<BR><BR>";
        print "Customer name: </B>$name<BR>";
        print "<B>Customer phone number: </B>$phone";
        print "</H3><BR>\n";
    }
    return 1;
}

#----------------------
# ReadParse
# This subroutine reads the arguments passed from the form

sub ReadParse {
    local ($i, $loc, $key, $val);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {                      # Read in text
       $in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
	$in .=getc;
      }
  } else 
  {  # can be used for debugging on command line
      $in = <STDIN>;
      print "$in\n";
  }

    @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
      $in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
				# Convert %XX from hex numbers to alphanumeric
      $loc = index($in[$i], "=");                  # Split onto key and value.
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
   }
   return 1;
}
