typedef struct	PM_type physical_memory;

struct	PM_type {
	short	process;
	short	VM;
	};

typedef struct	Queue_type queue;

struct	Queue_type {
	short	process;
	queue	*next;
	};

typedef struct	FIFO_type page_list;

struct	FIFO_type {
	short	    process;
	short	    VM;
	page_list   *next;
	};

typedef struct	LRU_type lru_list;

struct	LRU_type {
	short	    process;
	short	    VM;
	lru_list    *before;
	lru_list    *next;
	};

typedef struct	Page_table_type page_table;

struct	Page_table_type {
	short	present;
	short	number;
	};

#define     MAX_PAGE	8
#define     EMPTY	-99
#define     ABSENT	0
#define     PRESENT	1
#define     TRUE	1
#define     FALSE	0

void initialization();
void add_w_queue( short process );
void del_w_queue( short process );
void add_b_queue( short process );
void del_b_queue( short process );
void display_p_memory();
void change_order( short number );
void page_fault( short number );

physical_memory page[8];

queue		*rq;
queue		*wq;
queue		*bq;

page_table	table[16][16];

short		run_process;

short		memory_full=FALSE;

short		blocked=FALSE;

long		no_of_page_fault=0;
