#include <stdio.h>
#include <stdlib.h>

#include "global.h"

page_list   *fifo;

main()
{
    char    buf[4];
    short   process;
    short   number;
    FILE    *fp;	/*xxxxx*/

    initialization();

    fp = fopen("myinput", "rt");

    while ( (fscanf(fp, "%s", buf)) != EOF /*xxx move*/) {
	switch ( buf[0] ) {
	    case 'W' : {
		process = (short)atoi( (char *)&buf[1] );
		add_w_queue(process);
		break;
	    }
	    case 'R' : {
		process = (short)atoi( (char *)&buf[1] );
		del_w_queue(process);
		run_process = process;
		break;
	    }
	    case 'B' : {
		process = (short)atoi( (char *)&buf[1] );
		add_b_queue(process);
		break;
	    }
	    case 'D' : {
		display_p_memory();
		break;
	    }
	    default : {
		number = (short)atoi( (char *)&buf[0] );
		if ( table[run_process][number].present ) {
		    change_order( table[run_process][number].number );
		}
		else {
		    page_fault(number);
		break;
		}
	    }
	}
    }
    fclose( fp );
    printf("# of page fault : %d\n", no_of_page_fault);
}

void initialization()
{
    int     i, j;

    for (i=0; i<8; i++) {
	page[i].process = EMPTY;
	page[i].VM = EMPTY;
    }

    rq = (queue *)malloc( sizeof(queue) );
    rq->process = EMPTY;
    rq->next = NULL;
    wq = (queue *)malloc( sizeof(queue) );
    wq->process = EMPTY;
    wq->next = NULL;
    bq = (queue *)malloc( sizeof(queue) );
    bq->process = EMPTY;
    bq->next = NULL;
    fifo = (page_list *)malloc( sizeof(page_list) );
    fifo->process = EMPTY;
    fifo->next = NULL;

    for (i=0; i<16; i++)
	for (j=0; j<16; j++) {
	    table[i][j].present = ABSENT;
	    table[i][j].number = EMPTY;
	}
}

void add_w_queue( short process )
{
    printf("W-%d\n", process);
}

void del_w_queue( short process )
{
    printf("w-(%d)\n", process);
}

void add_b_queue( short process )
{
    printf("B-%d\n", process);
}

void display_p_memory()
{
    short   i;

    for(i=0; i<8; i++) {
	if ( page[i].process == EMPTY )
	    printf("X ");
	else
	    printf("%d,%d ", page[i].process, page[i].VM);
    }
    printf("\n");
}

void page_fault( short number )
{
    page_list	*ptr;
    short	count=0;

    no_of_page_fault++;
    ptr = fifo;
    if (memory_full) {
	fifo = fifo->next;
	table[ptr->process][ptr->VM].present = ABSENT;
	table[run_process][number].present = PRESENT;
	table[run_process][number].number =
	    table[ptr->process][ptr->VM].number;
	page[table[run_process][number].number].process = run_process;
	page[table[run_process][number].number].VM = number;
	printf("Page Fault: (%d,%d) put in frame %d replacing (%d,%d)\n",
		run_process, number, table[run_process][number].number,
		ptr->process, ptr->VM);
	free(ptr);
	ptr = fifo;
	while ( ptr->next != NULL ) {
	    ptr = ptr->next;
	}
	ptr->next = (page_list *)malloc( sizeof(page_list) );
	ptr = ptr->next;
	ptr->process = run_process;
	ptr->VM = number;
	ptr->next = NULL;
    }
    else {
	if (fifo->process == EMPTY) {
	    fifo->process = run_process;
	    fifo->VM = number;
	}
	else {
	    count++;
	    while ( ptr->next != NULL ) {
		count++;
		ptr = ptr->next;
	    }
	    if ( count == MAX_PAGE - 1 )
		memory_full = TRUE;
	    ptr->next = (page_list *)malloc( sizeof(page_list) );
	    ptr = ptr->next;
	    ptr->process = run_process;
	    ptr->VM = number;
	    ptr->next = NULL;
	}
	table[run_process][number].present = PRESENT;
	table[run_process][number].number = count;
	page[count].process = run_process;
	page[count].VM = number;
	printf("Page Fault: (%d,%d) put in frame %d replacing (x,x)\n",
		run_process, number, count);
    }
    return;
}

void change_order( short number )
{
}
