#include <stdio.h>
#include <stdlib.h>

#define 	EMPTY		0
#define 	NINEBITS	0x00000fff
#define 	TENBITS 	0x000003ff
#define 	SIZE_SECOND	256
#define 	SIZE		(int)(1024*(SIZE_SECOND/64))

unsigned long	hit=0;
unsigned long	first_miss=0;
unsigned long	second_miss=0;
unsigned long	total=0;
unsigned long	cache[1024];
unsigned long	second[SIZE];

void initialization();

main()
{
    int 	    type;
    unsigned long   address;
    unsigned long   memory_block;
    unsigned long   cache_index;
    unsigned long   second_index;
    unsigned long   tag;

    initialization();

    while ( fscanf(stdin, "%d %x", &type, &address) != EOF ) {
	memory_block = address >> 6;
	tag = memory_block >> 10;
	cache_index = memory_block & TENBITS;
	total++;
	if ( cache[cache_index] == memory_block ) {
	    hit++;
	}
	else {
	    first_miss++;
	    second_index = memory_block & NINEBITS;
	    if ( second[second_index] == memory_block ) {
		cache[cache_index] = memory_block;
	    }
	    else {
		second_miss++;
		second[second_index] = memory_block;
		cache[cache_index] = memory_block;
	    }
	}
    }
    printf("Total memory reference : %d\n", total);
    printf("# of first miss : %d\n", first_miss);
    printf("# of second miss : %d\n", second_miss);
    printf("# of hit : %d\n", hit);
    printf("Miss ratio for the first_level cache : %7.5f\n",
	    (float)((float)first_miss/(float)total));
    printf("Local miss ratio : %7.5f\n",
	    (float)((float)second_miss/(float)first_miss));
    printf("Global miss ratio : %7.5f\n",
	    (float)((float)second_miss/(float)total));
}

void initialization()
{
    int     i;

    for(i=0; i<1024; i++)
	cache[i] = EMPTY;
    for(i=0; i<SIZE; i++)
	second[i] = EMPTY;
}
