#include <stdio.h>
#include <stdlib.h>

unsigned long	hit=0;
unsigned long	miss=0;
unsigned long	total=0;
unsigned long	cache[1024];

void initialization();

#define 	TENBITS     0x000003ff

main()
{
    int 	    type;
    unsigned long   address;
    unsigned long   memory_block;
    unsigned long   cache_block;
    unsigned long   tag;

    initialization();

    while ( fscanf(stdin, "%d %x", &type, &address) != EOF ) {
	memory_block = address >> 6;
	tag = memory_block >> 10;
	cache_block = memory_block & TENBITS;
	total++;
	if ( cache[cache_block] == memory_block ) {
	    hit++;
	}
	else { 
	    printf("cache_block : %x\n", cache_block);
	    miss++;
	    cache[cache_block] = memory_block;
	}
	printf("memory block : %x\n", memory_block);
    }
    printf("Total memory reference : %d\n", total);
    printf("# of miss : %d\n", miss);
    printf("# of hit : %d\n", hit);
    printf("Miss ratio : %6.4f\n", (float)((float)miss/(float)total));
}

void initialization()
{
    int     i;

    for(i=0; i<1024; i++)
	cache[i] = 0;
}
