import java.lang.*;
import java.io.*;
import java.applet.*;
import java.awt.*;
import sun.audio.*;

class SecondSound extends Applet implements Runnable {
  GraphControlPanel parent;
  public static Thread thread;
  public static byte buffer[] = new byte[8040];
  public static int exp_lut[] = {0,0,1,1,2,2,2,2,3,3,3,3,3,3,3,3,
				 4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
				 5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
				 5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
				 6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
				 6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
				 6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
				 6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
				 7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
				 7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
				 7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
				 7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
				 7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
				 7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
				 7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
				 7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7};

  SecondSound(GraphControlPanel parent) {
    this.parent = parent;
    byte info[] = {46, 115, 110, 100, 0, 0, 0, 40,
		0, 0, 31, 64, 0, 0, 0, 1,
		0, 0, 31, 64, 0, 0, 0, 1,
		111, 110, 101, 32, 100, 114, 105, 112,
		0, 0, 0, 0, 0, 0, 0, 0 };
    for(int i = 0; i<40; i++) {
      buffer[i] = info[i];
    }
    for(int i = 0; i<8000; i++) {
      int h = (int)parent.parent.graphs.graphSound.paper.f(i);
      buffer[i + 40] = linear2ulaw(get16Linear(h));
    }
  }

  public void start() {
    if (thread == null) {
      thread = new Thread(this);
      thread.start();
    }
  }

  public void stop() {
    if (thread != null) {
      thread.stop();
      thread = null;
    }
  }

  public void run() {
      AudioData audiodata = new AudioData(buffer);
      AudioDataStream audioStream = new AudioDataStream(audiodata);
      AudioPlayer.player.start(audioStream);
  }

  int get16Linear(int h) {
    int height = parent.parent.graphs.graphSound.paper.size().height;
    if ( h > height / 2 ) {
      return (h - height / 2) * 32768 / (height / 2);
    }
    else {
      return (height / 2 - h) * -32768 / (height / 2);
    }
  }

  byte linear2ulaw(int sample) {
    int sign, exponent, mantissa;
    byte ulawbyte;

    /* get the sample into sign-magnitude */
    sign = (sample >> 8) & 0x80;        // set aside the sign
    if (sign != 0) sample = -sample;    // get magnitude 
    if (sample > 32635) sample = 32635;   // clip the magnitude
    /* convert from 16 bit linear to ulaw */
    sample = sample + 0x84;
    exponent = exp_lut[(sample>>7) & 0xFF];
    mantissa = (sample >> (exponent+3)) & 0x0F;
    ulawbyte = (byte)~(sign | (exponent << 4) | mantissa);
    if (ulawbyte == 0 ) ulawbyte = 0x02;
    return(ulawbyte);
  }
}
