import java.applet.*;
import java.awt.*;
import java.lang.Math;
import java.util.*;

public class GraphDraw extends java.applet.Applet {
    GraphDrawCanvas	paper;
    GraphDrawPanel	board;

    public void init() {
	setLayout(new GridLayout(1, 2, 10, 10));
	paper = new GraphDrawCanvas(this);
	board = new GraphDrawPanel(this);
	add(paper);
	add(board);
	paper.setBackground(Color.black);
        paper.setForeground(Color.green);
	board.setBackground(Color.lightGray);
    }

    public void paint (Graphics g) {
	//paper.setBackground(Color.white);
	//board.setBackground(Color.pink);
	//board.setBackground(Color.lightGray);
	paper.paint(g);
	board.paint(g);
    }

    public void start() {
	paper.start();
	board.start();
    }
    
    public void stop() {
	paper.stop();
    }

    public void update(Graphics g) {
	paper.paint(g);
    }
}

class GraphDrawCanvas extends Canvas implements Runnable {

    GraphDraw parent;
    Thread thread;				//Thread variable
    double dx = 0.0;

    public GraphDrawCanvas(GraphDraw parent) {
	this.parent = parent;
	thread = new Thread(this);
    }

    public void start() {

	if (thread.isAlive()) {		//Checking the life of thread
	    thread.resume();		//If other page reference,
	}				// resume the thread.

	else {				//Start thread from begining
	    thread.start();
	}
    }

    public void stop() {		//Stop thread.
	thread.suspend();
    }

    public void destroy() {		//Destroy thread.
	thread.stop();
    }

    public void run() {
        while (true) {
  	    if ( dx > 5.45 || dx < -5.45 ) {
                dx = 0;
            }
            repaint();
            try { Thread.sleep(500); }
            catch (InterruptedException e) {}
        }
    }

    double f(double x) {
        return (Math.sin(x/10+dx) + 2 )* size().height / 4;
    }

    public void paint(Graphics g) {
        for (int x = 0 ; x < size().width ; x++) {
            g.drawLine(x, (int)f(x), x + 1, (int)f(x + 1));
        }
    }

    public void update_phase(int flag) {
        switch( flag ) {
	    case 1 : dx -= 0.785;
                     break;
	    case 2 : dx += 0.785;
                     break;
	    default : break;
	}
    }
}

class GraphDrawPanel extends Panel {
    GraphDraw parent;

    GraphDrawPanel(GraphDraw parent) {
	this.parent = parent;
	setLayout(new GridLayout(2, 1, 10, 5));

        add(new Button("+"));
        add(new Button("-"));
    }

    public void start() {
    }

    public void paint(Graphics g) {
    }

    public boolean action(Event evt, Object arg) {
        if (evt.target instanceof Button)
            changePhase((String)arg);
        return true;
    }

    void changePhase(String bname) {
        if (bname.equals("+")) parent.paper.update_phase(1);
        else if (bname.equals("-")) parent.paper.update_phase(2);
    }
}
