//******************************************************************************************
//
// Class AudioDecoder
//
// Author:			Tomasz Stachowiak
// Created:			--/--/--
// Modified:		09/12/97
// By:				Grzegorz Lewandowski
// Changes:			getBuffer changed to getData
//					putData added
//
//
//******************************************************************************************

abstract class AudioDecoder
{
	protected byte buffer[];
	protected int length;

	public AudioDecoder( int len )
	{
		length = len;
		buffer = new byte[ length ];
	}

	public byte[] getData()
	{
		return buffer;
	}

	abstract void decode();
	abstract void putData( byte[] data );
	abstract int getInputSize();
	public int getOutputSize()
	{
		return length;
	}
}

