//*****************************************************************************************
//
// Class AudioProvider
//
//*****************************************************************************************

abstract class AudioProvider implements Runnable
{
	protected byte[] outBuffer;
	protected byte[] inBuffer;
	protected int length;
	private AudioDecoder decoder;
	private AudioIOStream stream;

	public AudioProvider( AudioDecoder dec, AudioIOStream str )
	{
		decoder = dec;
		stream = str;
		//available = false;
		//eof = false;
		length = decoder.getOutputSize();
		inBuffer = new byte[ decoder.getInputSize() ];
		outBuffer = new byte[ decoder.getOutputSize() ];
	}

	public void run()
	{
		while( putAudio() )
		{
			decoder.putData( inBuffer );
			decoder.decode();
			outBuffer = decoder.getData();
			stream.write( outBuffer, outBuffer.length );
		}
		stream.setEOF();
		System.out.println( "AudioProvider: EOF" );
	}

	public abstract void close();
	protected abstract boolean putAudio();
}
