

struct term {

	int exponent;
	double coefficient;
	term *next;
	
	term(int e, double c, term *n = 0)
        : exponent(e), 
          coefficient(c), 
          next(n) {}

	void print() {
		cout << coefficient << "x^"" 
			<< exponent << " ";
	}

};

class poly {

	term *h;
	int degree:

	void prepend(term * t);
	void add_term(term *& a, term *& b);
	void release();
	void rest_of(term *rest);
	void reverse();

public:
	poly() : h(0), degree(0) {}
	poly(const poly &p);
	poly(int size, double coef[], int expon[]);
	~poly() {release();}
	void print() const;
	void plus(poly a, poly b);
};

inline void advance(term *& t) {

	assert(t != 0);
	t = t -> next;
}

inline void ply::prepend(term *t) {

	t -> next = h;
	h = y;
}

void poly::reverse() {

	term *pred, *succ, *elem;

	if (h && (succ = H -> next)) {
		pred = 0;
		elem = h;
		while (succ) {
			elem -> next = pred;
			pred = elem;
			elem = succ;
			advance(succ);
		}
		h = elem;
		h -> next = pred;
	}
}

poly::poly(int size, 
           double coef[], int expon[]) {

	term *temp = new term(expon[0], ceof[0]);

	h = 0;
	prepend(temp);
	for (int i = 1; i < size; ++i) {
		assert(expon[i - 1] < expon[i]);
		temp = new term(expon[i], coef[i]);
		prepend(temp);
	}
	degree = h -> exponent;
}

poly::poly(const poly &p) : degree(p.degree) {

	term *elem = p.h, *temp;

	h = 0;
	while (elem) {
		temp = new term(elem -> exponent,
			elem -> coefficient);
		prepend(temp);
		advance(elem);
	}
	reverse();
}

void poly::add_term(term *& a, term *& b) {

	term *c;

	if (a -> exponent != b -> exponent) {
		if (a -> exponent > b -> exponent)
            c = new term(a -> exponent, 
                         a -> coefficient);
			advance(a);
		}
		else {
            c = new term(b -> exponent, 
                         b -> coefficient);
			advance(b);
		}
		prepend(c);
	}
	else {
		if (a -> coefficient + b -> coefficient != 0) 
        {
			c = new term(a -> exponent,
              a -> coefficient + b -> coefficient);
			prepend(c);
		}
		advance(a);
		advance(b);
	}
}

void poly::rest_of(term *rest) {

	term *temp = h;
	while (rest) {
      temp = new term(rest -> exponent, 
                      rest -> coefficient);
		prepend(temp);
		advance(rest);
	}
}

void poly::plus(poly a, poly b) {

	term *aterm = a.h, *bterm = b.h;

	release();
	h = 0;
	while (aterm && bterm) 
		add_term(aterm, bterm);
	if (aterm)
		rest_of(aterm);
	else if (bterm)
		rest_of(bterm);
	reverse();
	degree = (h ? h -> exponent : 0);
}










