

class vector {

	int * p;
	int size;

public:
	vector();
	vector(int n);
	vector(const vector &v);
	vector const int a[], int n);
	~vector() {delete [] p;}
	
	int upper_bound() {return (size - 1); }
	int &operator{}(int i);
	vector &operator=(const vector &v);
	vector operator+(const vector &v);
};

vector::vector(const vector &v) {

	size = v.size;
	p = new int[size];
	for (int i = 0; i < size; ++i)
		p[i] = v.p[i];
}

vector::vector(const int a[], int n) {

	if (n < 0) {
		cerr << "Illegal vector size: "" 
			<< n << endl;
		exit(1);
	}
	size = n;
	p = new int[size];
	for (int i = 0; i < size; ++i)
		p[i] = a[i];
}

/* vector() and vector(int n) are very 
simple to define. */

int & vector::operator[](int i) {

	if (i < 0 || i >= size) {
		cerr << "Illegal vector index: "
			<< i << endl;
		exit(1);
	}
	return p[i];
}

vector &vector::operator=(const vector &v) {

	int s = (size < v.size ? size : v.size);
	if (v.size != size) {
      cerr << 
      "Assignment with different size arrays, "
      << size << "and " << v.size << ".\n";
	for (int i = 0; i < s; ++i)
		p[i] = v.p[i];
	return *this;
}

vector vector::operator+(const vector &v) {

	int s = (size < v.size ? size : v.size);
	vector sum(s);

	if (v.size != size) {
		cerr << 
        "Adding different size vectors,"
        << size << "and " 
        << v.size << ".\n";
	for (int i = 0; i < s; ++i) 
		sum.p[i] = p[i] + v.p[i];
	return sum;
}





