#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>

typedef struct app_areatag {
	char	*key;
	int		other_stuff;
}app_area;

static void print(app_area *p) {
	printf("%s ", p->key);
}

static int equal(app_area *p1, app_area *p2) {
	return strcmp(p1->key, p2->key) == 0;
}

void *simplified_allocator (
				int	size,
				int	(*constructor) (void *this, ...),
				...)
{
	va_list	args;
	void	*this;
	if (this = malloc(size)) {
		va_start(args, constructor);
		if (!(*constructor)(this, args)) {
			free(this);
			this = NULL;
		}
		va_end(args);
	}
	return this;
}

static int construct (app_area *this, va_list args)
{
	this->key = strdup(va_arg(args, char *));
	this->other_stuff = va_arg(args, int);
	return (this->key != NULL);
}

static void destruct(app_area *this)
{
	free(this->key);
}

static void copy(app_area *this, app_area *src)
{
	this->key = strdup(src->key);
}

static void assign(app_area *this, app_area *src)
{
	free(this->key);
	this->key = strdup(src->key);
	this->other_stuff = src->other_stuff;
}
