#include <signal.h>
#include <data_str.h>
#include <list.h>

#define	new_link(str)	((app_area *) new_list_ele(		\
				sizeof(app_area),						\
				copy, assign, print,					\
				equal, destruct,						\
				construct, (str), 0))

void out_of_mem_handler() {
	fprintf(stderr, "Out of memory.\n");
	exit(3);
}

void main()
{
	app_area	*member, *temp;
	/*app_area	*p1, *p2, *p3;*/
	app_area	look_for_this = {"Sa", 0};
	list	*a_list = new_list(), *b_list;

	signal(SIGABRT, (void *)out_of_mem_handler);

	member = (app_area *)new_list_ele (
				sizeof(app_area),
				copy,
				assign,
				print,
				equal,
				destruct,
				construct, "ill.", 8);

	temp = member;

	if (!enqueue(a_list, member))
		printf("'%s' is already a member.\n", member->key);

	member = (app_area *)new_list_ele (
				sizeof(app_area),
				copy,
				assign,
				print,
				equal,
				destruct,
				construct, "is", 4);


	if (!enqueue(a_list, member))
		printf("'%s' is already a member.\n", member->key);
 
	if (!enqueue(a_list, temp))
		printf("'%s' is already a member.\n", temp->key);
  	/*
	p1 = new_link("Sam");
	p2 = new_link("Sax");
	le_copy(p2, p1);

	if (le_equal(p1, p2)) {
		le_print(p1);
		printf("== ");
		le_print(p2);
		printf("\n");
	}
	*/
	member = new_link("Sam");
   	if (!enqueue(a_list, member))
		printf("'%s' is already a member.\n", member->key);
	/*
	p3 = (app_area *)simplified_allocator(sizeof(app_area),
										construct, "Samson", 12);

	/*le_copy(p1, p3);
	/*destruct(p3);
	
	printf("Original member was ");
	le_print(p2);
	le_assign(p2, p1);
	printf(", and assigned member is ");
	le_print(p2);
	printf("\n");
   				   */
	member = new_link("Sa");
	if (!enqueue(a_list, member))
		printf("'%s' is already a member.\n", member->key);

	member = new_link("oh");
	if (!enqueue(a_list, member))
		printf("'%s' is already a member.\n", member->key);

	printf("A list :\n");
	list_print(a_list, FORWARD);
	printf("\n");

	b_list = new_list();
	list_assign(b_list, a_list);
	/*pop(b_list);
	/*
 	member = new_link("Oh!");
	if (!push(b_list, member))
		printf("'%s' is already a member.\n", member->key);
	/*
	if (!(member = (app_area*)list_find(b_list, &look_for_this)))
		printf("'%s' is not in the list.\n", look_for_this.key);
	list_unlink(b_list, member);
	delete_list_ele(member);
	*/
	printf("B list :\n");
	list_print(b_list, BACKWARD);
	printf("\n");

	delete_list(b_list);
}

int List_ele_err;
int List_err;

void _delete_chain(_list_ele *head) {
	_list_ele *next;
	for(; head; head = next) {
		next = head -> next;
		delete_list_ele(head);
	}
}

list *new_list(void) {
	list *this;
	List_err = LIST_NOERR;
	if (!(this= (list *)calloc(1, sizeof(list)))) {
		List_err - LIST_NOMEM;
		raise(SIGABRT);
	}
	return this;
}

void *new_list_ele(size_t app_size,
			void (*copy) (void *this, void *src),
			void (*assign) (void *this, void *src),
			void (*print) (void *this),
			int  (*equal) (void *this, void *key),
			void (*destruct) (void *this),
			int  (*construct) (void *this, ...),
			...) {

	va_list		args;
	_list_ele	*this;
	List_ele_err = LIST_NOERR;

	va_start(args, construct);
	if (!(this = (_list_ele *)
				malloc(sizeof(_list_ele)) + app_size)) {
		List_ele_err = LIST_NOINIT;
		free(this);
		this = NULL;
	}
	else {
		this->next = NULL;
		this->prev = NULL;
		this->app_size = app_size;
		this->copy = copy;
		this->assign = assign;
		this->print = print;
		this->equal = equal;
		this->destruct = destruct;
		this += 1;
	}
	if (construct) construct((app_area *)this, args);
	va_end(args);
	if (List_ele_err) raise(SIGABRT);
	return this;
}

void *list_find(list *this, void *obj) {
	_list_ele *cur;
	int	index = 0;

	for (cur = this->head; cur; cur->next, ++index) {
		if ((*cur->equal) ((void*)(cur + 1), obj)) {
			this->index = index;
			this->current = cur;
			return (cur + 1);
		}
	}
	return NULL;
}

void *list_index(list *this, int index) {
	_list_ele *cur = this->current;
	int n = index;

	if (!(0 <= index && index < this->num_ele) )
		cur = NULL;
	else if (cur == NULL
			|| abs(this->index - n) >= n) {
		for (cur = this->head; cur && --n >= 0; cur = cur->next);
	}
	else {
		while (--n >= 0 && cur)
			cur = cur->next;
	}
	if (cur) {
		this->current = cur;
		this->index = index;
	}
	return cur ? cur + 1 : NULL;
}

int enqueue(list *this,void *usr_space) {
	_list_ele	*ele = (_list_ele *)usr_space - 1;

	if (ele->next || ele->prev) return 0;
	if ( !(this->head) ) {
		ele->next = NULL;
		ele->prev = NULL;
		this->head = this->tail = ele;
	}
	else {
		ele->next = NULL;
		ele->prev = this->tail;
		this->tail->next = ele;
		this->tail = ele;
	}
	this->current = ele;
	this->index = this->num_ele;
	this->num_ele++;
	return 1;
}

void *list_unlink(list *this, void *usr_space) {
	_list_ele *ele = (_list_ele *)usr_space - 1;

	if (!usr_space) return NULL;

	if (this->head != ele && !ele->prev && !ele->next)
		return NULL;

	if (ele == this->current) {
		if (this->current = ele->next)
			++this->index;
		else {
			this->current = ele->prev;
			--this->index;
		}
	}

	if (this->head == this->tail) {
		this->head = this->tail = NULL;
	}
	else if (ele == this->head) {
		this->head = ele->next;
		this->head->prev = NULL;
	}
	else if (ele == this->tail) {
		this->tail = ele->prev;
		this->tail->next = NULL;
	}
	else {
		ele->prev->next = ele->next;
		ele->next->prev = ele->prev;
	}
	ele->prev = ele->next = NULL;
	return usr_space;
}

void list_dup(list *this) {
	_list_ele	*cur;
	void		*member;
	list 		*new = new_list();

	for (cur = this->head; cur; cur = cur->next) {
		member = new_list_ele(cur->app_size,
							  cur->copy,
							  cur->assign,
							  cur->print,
							  cur->equal,
							  cur->destruct,
							  NULL);
		(*cur->copy) (member, cur + 1);
		enqueue(new, member);
		if (this->current == cur) {
			new->current = (_list_ele *)member - 1;
			new->index = this->index;
		}
	}
}

void list_assign(list *this, const list *src) {
	_list_ele *src_ele, *dst_ele, *new_ele=NULL;
	list *new = new_list();

	dst_ele = this->head;
	for (src_ele = src->head; src_ele; src_ele = src_ele->next) {
		if (dst_ele) {
			(*src_ele->assign) (dst_ele + 1, src_ele + 1);
			if (src->current == src_ele) {
				new->current = dst_ele;
				new->index = src->index;
			}
			dst_ele = dst_ele->next;
		}
		else {
			new_ele = new_list_ele(src_ele->app_size,
								   src_ele->copy,
								   src_ele->assign,
								   src_ele->print,
								   src_ele->equal,
								   src_ele->destruct,
								   NULL);
			(*src_ele->copy) (new_ele, src_ele + 1);
			enqueue(new, new_ele);
			if (src->current == src_ele) {
				new->current = new_ele - 1;
				new->index = src->index;
			}
		}
	}

	if (dst_ele) {
		if (dst_ele == this->head) {
			this->head = this->tail = this->current = NULL;
			this->num_ele = this->index = 0;
		}
		else {
			this->tail = dst_ele->prev;
			dst_ele->prev->next = NULL;
		}
		_delete_chain(dst_ele);
	}
	else {
		if (new_ele) {
			printf("\nNew list :\n");
			list_print(new, FORWARD);
			printf("\n");
			if (dst_ele == this->head) {
				this->head = new->head;
				this->tail = new->tail;
				this->num_ele = new->num_ele;
				this->current = new->current;
				this->index = new->index;
			}
			else {
				new->head->prev = this->tail;
				this->tail->next = new->head;
				this->num_ele += new->num_ele;
				this->current = new->current;
				this->index += new->index;
			}
		}
	}
}

#ifdef DEBUG
#define D(x) x
#else
#define D(x)
#endif

void list_print(list *this, int forward) {
	_list_ele	*p;

	D( printf("list @%08p head=%04x, tail=%04x, num_ele=%d\n",\
			this, this->head, this->tail, this->num_ele); )
	p = forward ? this->head : this->tail;
	for (; p; p = forward ? p->next : p->prev) {
		D(printf("\t(@%04x):next=%04x prev=%04x->",	\
				p, p->next, p->prev);)
		(*p->print) (p+1);
	}
}
